Resent-Date: Mon, 16 Nov 1998 10:11:47 +0100 (MET)
Date: Sun, 15 Nov 1998 22:09:56 +0100 (CET)
From: Geert Uytterhoeven <Geert.Uytterhoeven@cs.kuleuven.ac.be>
To: Jes Sorensen <Jes.Sorensen@cern.ch>
cc: Linux/m68k <linux-m68k@lists.linux-m68k.org>,
        Linux/APUS <linux-apus@sunsite.auc.dk>
Subject: Fix for IDE doubler
Resent-From: linux-m68k@phil.uni-sb.de


This one was thrown up in my brain again...

--- jes-2.1.127/drivers/block/ide.c	Thu Nov 12 19:54:47 1998
+++ m68k/drivers/block/ide.c	Sun Nov 15 22:08:08 1998
@@ -1167,7 +1167,9 @@
 			return;
 		}
 		hwif = HWIF(drive);
-		if (hwgroup->hwif->sharing_irq && hwif != hwgroup->hwif) /* set nIEN for previous hwif */
+		if (hwgroup->hwif->sharing_irq && hwif != hwgroup->hwif &&
+		    hwif->io_ports[IDE_CONTROL_OFFSET])
+			/* set nIEN for previous hwif */
 			OUT_BYTE(hwgroup->drive->ctl|2, hwgroup->hwif->io_ports[IDE_CONTROL_OFFSET]);
 		hwgroup->hwif = hwif;
 		hwgroup->drive = drive;

Greetings,

						Geert

--
Geert Uytterhoeven                     Geert.Uytterhoeven@cs.kuleuven.ac.be
Wavelets, Linux/{m68k~Amiga,PPC~CHRP}  http://www.cs.kuleuven.ac.be/~geert/
Department of Computer Science -- Katholieke Universiteit Leuven -- Belgium

